MODULE YOERRTAM

#include "tsmbkind.h"

USE PARRRTM


IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOERRTAM* - RRTM definition of atmospheric profiles
!     includes all commons with arrays depending on vertical coordinate
!     ------------------------------------------------------------------

REAL_B   , ALLOCATABLE, DIMENSION(:,:,:) :: TAU

REAL_B   , ALLOCATABLE, DIMENSION(:,:) :: TAUAERL

REAL_B   , ALLOCATABLE, DIMENSION(:) :: FAC00 , FAC01 , FAC10 , FAC11
INTEGER_M, ALLOCATABLE, DIMENSION(:) :: JP    , JT    , JT1
REAL_B    :: ONEMINUS
REAL_B   , ALLOCATABLE, DIMENSION(:) :: COLH2O, COLCO2, COLO3 &
                                    &, COLN2O, COLCH4, COLO2 &
                                    &, CO2MULT 
INTEGER_M :: LAYTROP, LAYSWTCH, LAYLOW
REAL_B   , ALLOCATABLE, DIMENSION(:) :: PAVEL , TAVEL
REAL_B   , ALLOCATABLE, DIMENSION(:) :: PZ    , TZ
REAL_B    :: TBOUND
INTEGER_M :: NLAYERS
REAL_B   , ALLOCATABLE, DIMENSION(:) :: SELFFAC, SELFFRAC
INTEGER_M, ALLOCATABLE, DIMENSION(:) :: INDSELF
REAL_B   , ALLOCATABLE, DIMENSION(:,:,:) :: PFRAC
REAL_B   , ALLOCATABLE, DIMENSION(:) :: SEMISS
REAL_B    :: SEMISLW
INTEGER_M :: IREFLECT
INTEGER_M :: NUMANGS, IOUT, ISTART, IEND
REAL_B   , ALLOCATABLE, DIMENSION(:) :: COLDRY , WBRODL
REAL_B   , ALLOCATABLE, DIMENSION(:) :: CLDFRAC
REAL_B   , ALLOCATABLE, DIMENSION(:,:) :: TAUCLDU, TAUCLDD
INTEGER_M :: NMOL, IXSECT, NXMOL
REAL_B   , ALLOCATABLE, DIMENSION(:,:) :: WKL
INTEGER_M, ALLOCATABLE, DIMENSION(:) :: IXINDX
REAL_B   , ALLOCATABLE, DIMENSION(:,:) :: WX
REAL_B   , ALLOCATABLE, DIMENSION(:) :: FORFAC
INTEGER_M, ALLOCATABLE, DIMENSION(:) :: INDLAY
INTEGER_M, ALLOCATABLE, DIMENSION(:) :: INDLEV

!     -----------------------------------------------------------------
!        * E.C.M.W.F. PHYSICS PACKAGE ** RRTM LW RADIATION **

!     J.-J. MORCRETTE       E.C.M.W.F.      98/07/14
!     -----------------------------------------------------------------
!$OMP threadprivate ( &
!$OMP   JP    , JT    , JT1 &
!$OMP , LAYTROP, LAYSWTCH, LAYLOW &
!$OMP , NLAYERS &
!$OMP , INDSELF &
!$OMP , IREFLECT &
!$OMP , NUMANGS, IOUT, ISTART, IEND &
!$OMP , NMOL, IXSECT, NXMOL &
!$OMP , IXINDX &
!$OMP , INDLAY &
!$OMP , INDLEV &
!$OMP , TAU &
!$OMP , TAUAERL &
!$OMP , FAC00 , FAC01 , FAC10 , FAC11 &
!$OMP , ONEMINUS &
!$OMP , COLH2O, COLCO2, COLO3 & 
!$OMP , COLN2O, COLCH4, COLO2 &
!$OMP , CO2MULT &
!$OMP , PAVEL , TAVEL &
!$OMP , PZ    , TZ &
!$OMP , TBOUND &
!$OMP , SELFFAC, SELFFRAC &
!$OMP , PFRAC &
!$OMP , SEMISS &
!$OMP , SEMISLW &
!$OMP , COLDRY , WBRODL &
!$OMP , CLDFRAC &
!$OMP , TAUCLDU, TAUCLDD &
!$OMP , WKL &
!$OMP , WX &
!$OMP , FORFAC &
!$OMP )
END MODULE YOERRTAM
