

      subroutine wind_rot(uurot,vvrot,ux,vy)
 
! +--------------------------------------------------------------------------+
! |                                                                1-12-2019 |
! |   subroutine wind_rot transfers MAR-gridded winds to a regular grid      |
! |                           NEAR-SURFACE WIND only for now                 |
! |   currently used in - mar_2_oasis for converting wind to Nemo grid       |
! |                     - outice for UU to UX and VV to VY wind              |
! |                                                                          |
! |      C. Kittel                                                           |
! +--------------------------------------------------------------------------+

      IMPLICIT NONE
      
      include  "MARdim.inc" !mx,my
      include  "MARphy.inc" !pi
      include  "MAR_GE.inc"
      
      integer i,j
      real dr, deltaphi,phi,cphi,sphi
      real lonmar(mx,my)
      real uurot(mx,my),vvrot(mx,my),ux(mx,my),vy(mx,my)
 
      dr   = degrad

      deltaphi = 90. - GEddxx
      
       ux=uurot
       vy=vvrot
      do j=1,my ; do i=1,mx
       lonmar(i,j)=gelonh(i,j) *15.d0
       phi = (-1.) * (lonmar(i,j)+deltaphi)*dr
       cphi = cos( -phi )
       sphi = sin( -phi )
       ux(i,j) = cphi*uurot(i,j) - sphi*vvrot(i,j)
       vy(i,j) = sphi*uurot(i,j) + cphi*vvrot(i,j)
      enddo; enddo
      
      
      end subroutine
